## cbmc 6.1.1

=== src/solvers/CMakeLists.txt ===
#   We may use one of several different solver libraries.
#   The following files wrap the chosen solver library.
#   We remove them all from the solver-library sources list, and then add the
#   ones we actually need back in.
set(chaff_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_zchaff.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_zcore.cpp
)
set(minisat_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_minisat.cpp
)
set(minisat2_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_minisat2.cpp
)
set(glucose_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_glucose.cpp
)
set(squolem2_source
    ${CMAKE_CURRENT_SOURCE_DIR}/qbf/qbf_squolem.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qbf/qbf_squolem_core.cpp
)
set(cudd_source
    ${CMAKE_CURRENT_SOURCE_DIR}/qbf/qbf_bdd_core.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qbf/qbf_skizzo_core.cpp
)
set(picosat_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_picosat.cpp
)
set(lingeling_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_lingeling.cpp
)
set(booleforce_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_booleforce.cpp
)
set(minibdd_source
    ${CMAKE_CURRENT_SOURCE_DIR}/bdd/miniBDD/example.cpp
)
set(ipasir_source
    ${CMAKE_CURRENT_SOURCE_DIR}/sat/satcheck_ipasir.cpp
)


file(GLOB_RECURSE sources "*.cpp" "*.h")
list(REMOVE_ITEM sources
    ${chaff_source}
    ${minisat_source}
    ${minisat2_source}
    ${glucose_source}
    ${squolem2_source}
    ${cudd_source}
    ${picosat_source}
    ${lingeling_source}
    ${booleforce_source}
    ${minibdd_source}
    # ${ipasir_source}
    ${CMAKE_CURRENT_SOURCE_DIR}/bdd/example.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/smt2/smt2_solver.cpp
)

add_library(solvers ${sources})

include("${CBMC_SOURCE_DIR}/../cmake/DownloadProject.cmake")

foreach(SOLVER ${sat_impl})
    if("${SOLVER}" STREQUAL "minisat2")
        message(STATUS "Building solvers with minisat2")

        # once we upgrade to CMake 3.7 or higher we can specify multiple URLs as a
        # fall-back in case the first URL fails (the Makefile-based build retries up
        # to 2 times)
        download_project(PROJ minisat2
            URL http://ftp.debian.org/debian/pool/main/m/minisat2/minisat2_2.2.1.orig.tar.gz
            PATCH_COMMAND patch -p1 -i ${CBMC_SOURCE_DIR}/../scripts/minisat-2.2.1-patch
            COMMAND cmake -E copy ${CBMC_SOURCE_DIR}/../scripts/minisat2_CMakeLists.txt CMakeLists.txt
            URL_MD5 27faa19ee0508660bd6fb7f894646d42
        )

        add_subdirectory(${minisat2_SOURCE_DIR} ${minisat2_BINARY_DIR})

        target_compile_definitions(solvers PUBLIC
            SATCHECK_MINISAT2 HAVE_MINISAT2 __STDC_FORMAT_MACROS __STDC_LIMIT_MACROS
        )

        target_sources(solvers PRIVATE ${minisat2_source})

        target_link_libraries(solvers minisat2-condensed)
    elseif("${SOLVER}" STREQUAL "system-minisat2")
        include(CheckIncludeFileCXX)
        # if/when we move to CMake 3.12 (or later) we could also check for the
        # library via CMAKE_REQUIRED_LIBRARIES
        find_path(minisat_header_found "minisat/simp/SimpSolver.h")
        if(minisat_header_found)
            message(STATUS "Building solvers with minisat2 (${minisat_header_found})")
            target_compile_definitions(solvers PUBLIC SATCHECK_MINISAT2 HAVE_MINISAT2)
            target_sources(solvers PRIVATE ${minisat2_source})
            target_include_directories(solvers PRIVATE ${minisat_header_found})
            target_link_libraries(solvers minisat)
        else()
            message(FATAL_ERROR "Unable to find header file for preinstalled minisat2")
        endif()
    elseif("${SOLVER}" STREQUAL "glucose")
        message(STATUS "Building solvers with glucose")

        download_project(PROJ glucose
            URL https://github.com/BrunoDutertre/glucose-syrup/archive/0bb2afd3b9baace6981cbb8b4a1c7683c44968b7.tar.gz
            PATCH_COMMAND patch -p1 -i ${CBMC_SOURCE_DIR}/../scripts/glucose-syrup-patch
            COMMAND cmake -E copy ${CBMC_SOURCE_DIR}/../scripts/glucose_CMakeLists.txt CMakeLists.txt
            URL_MD5 7c539c62c248b74210aef7414787323a
        )

        add_subdirectory(${glucose_SOURCE_DIR} ${glucose_BINARY_DIR})

        target_compile_definitions(solvers PUBLIC
            SATCHECK_GLUCOSE HAVE_GLUCOSE __STDC_FORMAT_MACROS __STDC_LIMIT_MACROS
        )

        target_sources(solvers PRIVATE ${glucose_source})

        target_link_libraries(solvers glucose-condensed)
    elseif("${SOLVER}" STREQUAL "cadical")
        message(STATUS "Building solvers with cadical")

        download_project(PROJ cadical
            URL https://github.com/arminbiere/cadical/archive/rel-2.0.0.tar.gz
            PATCH_COMMAND patch -p1 -i ${CBMC_SOURCE_DIR}/../scripts/cadical-2.0.0-patch
            COMMAND cmake -E copy ${CBMC_SOURCE_DIR}/../scripts/cadical_CMakeLists.txt CMakeLists.txt
            COMMAND ./configure
            URL_MD5 9fc2a66196b86adceb822a583318cc35
        )

        add_subdirectory(${cadical_SOURCE_DIR} ${cadical_BINARY_DIR})

        target_compile_definitions(solvers PUBLIC
            SATCHECK_CADICAL HAVE_CADICAL
        )

        target_include_directories(solvers
            PUBLIC
            ${cadical_SOURCE_DIR}/src
        )

        target_link_libraries(solvers cadical)
    elseif("${SOLVER}" STREQUAL "ipasir-cadical")
        message(STATUS "Building with IPASIR solver linking against: CaDiCaL")

        download_project(PROJ cadical
            URL https://github.com/arminbiere/cadical/archive/rel-2.0.0.tar.gz
            PATCH_COMMAND patch -p1 -i ${CBMC_SOURCE_DIR}/../scripts/cadical-2.0.0-patch
            COMMAND ./configure
            URL_MD5 9fc2a66196b86adceb822a583318cc35
        )

        message(STATUS "Building CaDiCaL")
        execute_process(COMMAND make WORKING_DIRECTORY ${cadical_SOURCE_DIR})

        target_compile_definitions(solvers PUBLIC
            SATCHECK_IPASIR HAVE_IPASIR IPASIR=${cadical_SOURCE_DIR}/src
        )

        add_library(cadical_ipasir STATIC IMPORTED)
        set_property(TARGET cadical_ipasir
            PROPERTY IMPORTED_LOCATION ${cadical_SOURCE_DIR}/build/libcadical.a
        )

        target_include_directories(solvers
            PUBLIC
            ${cadical_SOURCE_DIR}/src
        )
        target_link_libraries(solvers cadical_ipasir)
    elseif("${SOLVER}" STREQUAL "system-cadical")
        include(CheckIncludeFileCXX)
        # if/when we move to CMake 3.12 (or later) we could also check for the
        # library via CMAKE_REQUIRED_LIBRARIES
        find_path(cadical_header_found "cadical.hpp")
        if(cadical_header_found)
            message(STATUS "Building solvers with cadical (${cadical_header_found})")
            target_compile_definitions(solvers PUBLIC SATCHECK_CADICAL HAVE_CADICAL)
            target_include_directories(solvers PRIVATE ${cadical_header_found})
            target_link_libraries(solvers cadical)
        else()
            message(FATAL_ERROR "Unable to find header file for preinstalled cadical")
        endif()
    elseif("${SOLVER}" STREQUAL "ipasir-custom")
        message(STATUS "Building with IPASIR solver linking: custom solver provided")

        if (NOT DEFINED IPASIR)
            message(FATAL_ERROR
              "IPASIR solver source code not provided. Please use -DIPASIR=<location> "
              "with <location> being the path to the IPASIR solver source code."
            )
        endif()

        if (NOT DEFINED IPASIR_LIB)
            message(FATAL_ERROR
                "IPASIR solver library not provided. Please use -DIPASIR_LIB=<location> "
                "with <location> being the path to the IPASIR solver precompiled static "
                "library."
            )
        endif()

        target_compile_definitions(solvers PUBLIC
            SATCHECK_IPASIR HAVE_IPASIR IPASIR=${IPASIR}
        )

        add_library(ipasir_custom STATIC IMPORTED)
        set_property(TARGET ipasir_custom
            PROPERTY IMPORTED_LOCATION ${IPASIR_LIB}
        )

        target_include_directories(solvers
            PUBLIC
            ${IPASIR}
        )
        target_link_libraries(solvers ipasir_custom pthread)
    endif()
endforeach()

if(CMAKE_USE_CUDD)
    target_link_libraries(solvers util cudd-cplusplus cudd)
    target_include_directories(solvers
        PUBLIC
        ${CUDD_INCLUDE}/cudd/
    )
else()
    target_link_libraries(solvers util)
endif()

# Executable
add_executable(smt2_solver smt2/smt2_solver.cpp)
target_link_libraries(smt2_solver solvers)

generic_includes(solvers)

=== debian/changelog ===
cbmc (6.1.1-2) unstable; urgency=low

  * Fix support for ARM-specific vector types

 -- Michael Tautschnig <mt@debian.org>  Fri, 02 Aug 2024 11:58:55 +0000

cbmc (6.1.1-1) unstable; urgency=low

  * New upstream release, which includes support for building with GCC 14
    (Closes: #1074869)
  * Support ARM-specific vector types (Closes: #1070441)

 -- Michael Tautschnig <mt@debian.org>  Thu, 01 Aug 2024 17:57:12 +0000

## cbmc 6.4.1

=== src/CMakeLists.txt ===
find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(CONFIGURED_DOXYFILE "${CMAKE_BINARY_DIR}/doxyfile")
  set(DOC_INPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")
  set(DOC_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/doc")

  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/doxyfile.override.in" "${CONFIGURED_DOXYFILE}" @ONLY)
  add_custom_target(doc
      COMMAND "${CMAKE_COMMAND}" -E remove_directory "${DOC_OUTPUT_DIRECTORY}"
      COMMAND "${CMAKE_COMMAND}" -E copy_directory "${DOC_INPUT_DIRECTORY}" "${DOC_OUTPUT_DIRECTORY}"
      COMMAND "${DOXYGEN_EXECUTABLE}" "${CONFIGURED_DOXYFILE}"
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif(DOXYGEN_FOUND)

#   Add a bison target named 'parser'.
macro(generic_bison name)
    set(bison_header "${name}_y.tab.h")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${bison_header}")
        message(FATAL_ERROR "Generated file ${bison_header} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    set(bison_source "${name}_y.tab.cpp")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${bison_source}")
        message(FATAL_ERROR "Generated file ${bison_source} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    if(${BISON_VERSION} VERSION_GREATER "2.3")
      set(bison_warnings_as_errors "-Werror")
    endif()
    bison_target(
        parser
        "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
        "${CMAKE_CURRENT_BINARY_DIR}/${bison_source}"
        COMPILE_FLAGS "${bison_warnings_as_errors} -pyy${name}"
    )
    set(renamed_parser_header "${CMAKE_CURRENT_BINARY_DIR}/${bison_header}")
    add_custom_command(OUTPUT "${renamed_parser_header}"
        COMMAND "${CMAKE_COMMAND}" -E copy "${BISON_parser_OUTPUT_HEADER}" "${renamed_parser_header}"
        MAIN_DEPENDENCY "${BISON_parser_OUTPUT_HEADER}"
    )
    list(REMOVE_ITEM BISON_parser_OUTPUTS "${BISON_parser_OUTPUT_HEADER}")
    list(APPEND BISON_parser_OUTPUTS "${renamed_parser_header}")
endmacro(generic_bison)

#   Add a flex target named 'scanner'
macro(generic_flex name)
    set(flex_source "${name}_lex.yy.cpp")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${flex_source}")
        message(FATAL_ERROR "Generated file ${flex_source} found in source tree. If you previously built with `make`, run `make clean` and try again")
    endif()

    flex_target(
        scanner
        "${CMAKE_CURRENT_SOURCE_DIR}/scanner.l"
        "${CMAKE_CURRENT_BINARY_DIR}/${name}_lex.yy.cpp"
        COMPILE_FLAGS "-Pyy${name}"
    )
endmacro(generic_flex)

#   Set the public include locations for a target.
macro(generic_includes name)
    target_include_directories(${name}
        PUBLIC
        ${CBMC_BINARY_DIR}/src
        ${CBMC_SOURCE_DIR}/src
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
endmacro(generic_includes)

#   Link optional modules.
#   Target is the name of the target with optional components.
#   Name is the name of the optional target.
#   Also adds a compile flag signalling to the preprocessor that the library is
#   used.
macro(add_if_library target name)
    if(TARGET ${name})
        target_link_libraries(${target} ${name})

        string(TOUPPER ${name} upper_name)
        string(REGEX REPLACE "-" "_" define ${upper_name})

        target_compile_definitions(${target} PUBLIC HAVE_${define})
    endif()
endmacro(add_if_library)

add_subdirectory(analyses)
add_subdirectory(ansi-c)
add_subdirectory(assembler)
add_subdirectory(big-int)
add_subdirectory(cpp)
add_subdirectory(xmllang)
add_subdirectory(goto-checker)
add_subdirectory(goto-programs)
add_subdirectory(goto-symex)
add_subdirectory(goto-inspect)
add_subdirectory(json)
add_subdirectory(json-symtab-language)
add_subdirectory(langapi)
add_subdirectory(linking)
add_subdirectory(pointer-analysis)
add_subdirectory(solvers)
add_subdirectory(statement-list)
add_subdirectory(util)

add_subdirectory(cbmc)
add_subdirectory(cprover)
add_subdirectory(crangler)
add_subdirectory(goto-cc)
add_subdirectory(goto-instrument)
add_subdirectory(goto-analyzer)
add_subdirectory(goto-diff)
add_subdirectory(goto-harness)
add_subdirectory(goto-synthesizer)
add_subdirectory(symtab2gb)
add_subdirectory(libcprover-cpp)
add_subdirectory(goto-bmc)

if(WITH_MEMORY_ANALYZER)
add_subdirectory(memory-analyzer)
endif()

=== src/Makefile ===
DIRS = analyses \
       ansi-c \
       assembler \
       big-int \
       cbmc \
       cpp \
       cprover \
       crangler \
       goto-analyzer \
       goto-bmc \
       goto-cc \
       goto-checker \
       goto-diff \
       goto-inspect \
       goto-instrument \
       goto-harness \
       goto-programs \
       goto-symex \
       goto-synthesizer \
       json \
       json-symtab-language \
       langapi \
       libcprover-cpp \
       linking \
       memory-analyzer \
       pointer-analysis \
       solvers \
       statement-list \
       symtab2gb \
       util \
       xmllang \
       # Empty last line

all: cbmc.dir \
     cprover.dir \
     crangler.dir \
     goto-analyzer.dir \
     goto-bmc.dir \
     goto-cc.dir \
     goto-diff.dir \
     goto-instrument.dir \
     goto-inspect.dir \
     goto-harness.dir \
     goto-synthesizer.dir \
     symtab2gb.dir \
     # Empty last line

ifndef WITH_MEMORY_ANALYZER
  ifeq ($(OS),Windows_NT)
    WITH_MEMORY_ANALYZER = 0
  else
    detected_OS := $(shell sh -c 'uname 2>/dev/null || echo Unknown')
    detected_ARCH := $(shell sh -c 'uname -m 2>/dev/null || echo Unknown')
    ifeq ($(filter-out Linux_x86_64 Linux_i386,$(detected_OS)_$(detected_ARCH)),)
      WITH_MEMORY_ANALYZER = 1
    else
      WITH_MEMORY_ANALYZER = 0
    endif
  endif
endif

ifeq ($(WITH_MEMORY_ANALYZER),1)
  all: memory-analyzer.dir
endif

###############################################################################

util.dir: big-int.dir

# everything but big-int depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

ansi-c.dir: analyses.dir

cpp.dir: ansi-c.dir linking.dir

crangler.dir: util.dir json.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir assembler.dir \
           json.dir json-symtab-language.dir statement-list.dir

solvers.dir: util.dir

goto-harness.dir: util.dir goto-programs.dir langapi.dir linking.dir \
                  json.dir json-symtab-language.dir \
                  goto-instrument.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir analyses.dir solvers.dir

goto-inspect.dir: util.dir goto-programs.dir languages linking.dir

goto-checker.dir: solvers.dir goto-symex.dir goto-programs.dir

cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
          pointer-analysis.dir goto-programs.dir linking.dir \
          goto-instrument.dir goto-checker.dir

cprover.dir: ansi-c.dir langapi.dir solvers.dir goto-programs.dir \
             linking.dir analyses.dir

goto-analyzer.dir: languages analyses.dir goto-programs.dir linking.dir \
                   goto-instrument.dir goto-checker.dir

goto-diff.dir: languages goto-programs.dir pointer-analysis.dir \
               linking.dir analyses.dir goto-instrument.dir \
               solvers.dir goto-symex.dir

goto-cc.dir: languages goto-programs.dir linking.dir

memory-analyzer.dir: util.dir goto-programs.dir langapi.dir linking.dir \
	                   ansi-c.dir

symtab2gb.dir: util.dir goto-programs.dir langapi.dir linking.dir \
               json.dir json-symtab-language.dir ansi-c.dir

goto-synthesizer.dir: languages util.dir goto-programs.dir langapi.dir \
                    json.dir goto-checker.dir \
                    goto-instrument.dir

goto-bmc.dir: libcprover-cpp.dir

libcprover-cpp.dir: cbmc.dir

# building for a particular directory

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files

generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

# minisat2 and glucose download, for your convenience

DOWNLOADER = curl -L --remote-name
TAR = tar

minisat2-download:
	@echo "Downloading Minisat 2.2.1"
	@for i in $$(seq 1 3) ; do \
	  $(DOWNLOADER) \
	    http://ftp.debian.org/debian/pool/main/m/minisat2/minisat2_2.2.1.orig.tar.gz && \
	    exit 0 ; \
		$(RM) minisat2_2.2.1.orig.tar.gz ; \
	  if [ $$i -lt 3 ] ; then echo "Re-trying in 10 seconds" 1>&2 ; sleep 10 ; fi ; \
	done ; exit 1
	@$(TAR) xfz minisat2_2.2.1.orig.tar.gz
	@rm -Rf ../minisat-2.2.1
	@mv minisat2-2.2.1 ../minisat-2.2.1
	@(cd ../minisat-2.2.1; patch -p1 < ../scripts/minisat-2.2.1-patch)
	@rm minisat2_2.2.1.orig.tar.gz

cudd-download:
	@echo "Downloading Cudd 3.0.0"
	@$(DOWNLOADER) https://sourceforge.net/projects/cudd-mirror/files/cudd-3.0.0.tar.gz/download cudd-3.0.0.tar.gz
	@$(TAR) xfz cudd-3.0.0.tar.gz
	@$(RM) -r ../cudd-3.0.0
	@mv cudd-3.0.0 ../
	@$(RM) cudd-3.0.0.tar.gz
	@echo "Compiling Cudd 3.0.0"
	@(cd ../cudd-3.0.0; ./configure; $(MAKE))

glucose_rev = 0bb2afd3b9baace6981cbb8b4a1c7683c44968b7
glucose-download:
	@echo "Downloading glucose-syrup"
	@$(DOWNLOADER) https://github.com/BrunoDutertre/glucose-syrup/archive/$(glucose_rev).tar.gz
	@$(TAR) xfz $(glucose_rev).tar.gz
	@rm -Rf ../glucose-syrup
	@mv glucose-syrup-$(glucose_rev) ../glucose-syrup
	@(cd ../glucose-syrup; patch -p1 < ../scripts/glucose-syrup-patch)
	@$(RM) $(glucose_rev).tar.gz

cadical_release = rel-2.0.0
cadical-download:
	@echo "Downloading CaDiCaL $(cadical_release)"
	@$(DOWNLOADER) https://github.com/arminbiere/cadical/archive/$(cadical_release).tar.gz
	@$(TAR) xfz $(cadical_release).tar.gz
	@rm -Rf ../cadical
	@mv cadical-$(cadical_release) ../cadical
	@(cd ../cadical; patch -p1 < ../scripts/cadical-2.0.0-patch)
	@(cd ../cadical && ./configure CXX="$(CXX)")
	# Need to rename VERSION so that it isn't picked up by `#include<version>` on
	# macOS which is case insensitive
	@(cd ../cadical && mv VERSION VERSION.txt)
	@$(RM) $(cadical_release).tar.gz

doc :
	doxygen

install: all
	for b in \
		cbmc crangler \
		goto-analyzer goto-cc goto-diff goto-instrument goto-inspect goto-harness \
    goto-synthesizer symtab2gb ; do \
		  cp $$b/$$b $(PREFIX)/bin/ ; \
			cp ../doc/man/$$b.1 $(PREFIX)/doc/man/man1/ ; \
	done
	ln -sf $(PREFIX)/bin/goto-cc $(PREFIX)/bin/goto-gcc
	ln -sf $(PREFIX)/bin/goto-cc $(PREFIX)/bin/goto-ld
	cp ../scripts/ls_parse.py $(PREFIX)/bin/

.PHONY: minisat2-download cudd-download glucose-download cadical-download install

=== unit/Makefile ===
.PHONY: all cprover.dir test testing-utils-clean

# Source files for test utilities
SRC = unit_tests.cpp \
      # Empty last line

# Test source files
SRC += analyses/ai/ai.cpp \
       analyses/ai/ai_simplify_lhs.cpp \
       analyses/call_graph.cpp \
       analyses/constant_propagator.cpp \
       analyses/dependence_graph.cpp \
       analyses/disconnect_unreachable_nodes_in_graph.cpp \
       analyses/does_remove_const/does_expr_lose_const.cpp \
       analyses/does_remove_const/does_type_preserve_const_correctness.cpp \
       analyses/does_remove_const/is_type_at_least_as_const_as.cpp \
       analyses/variable-sensitivity/abstract_environment/to_predicate.cpp \
       analyses/variable-sensitivity/abstract_object/merge.cpp \
       analyses/variable-sensitivity/abstract_object/index_range.cpp \
       analyses/variable-sensitivity/constant_abstract_value/meet.cpp \
       analyses/variable-sensitivity/constant_abstract_value/merge.cpp \
       analyses/variable-sensitivity/constant_abstract_value/to_predicate.cpp \
       analyses/variable-sensitivity/constant_pointer_abstract_object/to_predicate.cpp \
       analyses/variable-sensitivity/full_array_abstract_object/array_builder.cpp \
       analyses/variable-sensitivity/full_array_abstract_object/maximum_length.cpp \
       analyses/variable-sensitivity/full_array_abstract_object/merge.cpp \
       analyses/variable-sensitivity/full_array_abstract_object/to_predicate.cpp \
       analyses/variable-sensitivity/eval.cpp \
       analyses/variable-sensitivity/eval-member-access.cpp \
       analyses/variable-sensitivity/interval_abstract_value/extremes-go-top.cpp \
       analyses/variable-sensitivity/interval_abstract_value/meet.cpp \
       analyses/variable-sensitivity/interval_abstract_value/merge.cpp \
       analyses/variable-sensitivity/interval_abstract_value/to_predicate.cpp \
       analyses/variable-sensitivity/interval_abstract_value/widening_merge.cpp \
       analyses/variable-sensitivity/full_struct_abstract_object/merge.cpp \
       analyses/variable-sensitivity/full_struct_abstract_object/struct_builder.cpp \
       analyses/variable-sensitivity/full_struct_abstract_object/to_predicate.cpp \
       analyses/variable-sensitivity/last_written_location.cpp \
       analyses/variable-sensitivity/value_expression_evaluation/assume.cpp \
       analyses/variable-sensitivity/value_expression_evaluation/assume_prune.cpp \
       analyses/variable-sensitivity/value_expression_evaluation/expression_evaluation.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/extremes-go-top.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/compacting.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/meet.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/merge.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/to_predicate.cpp \
       analyses/variable-sensitivity/value_set_abstract_object/widening_merge.cpp \
       analyses/variable-sensitivity/value_set_pointer_abstract_object/to_predicate.cpp \
       analyses/variable-sensitivity/variable_sensitivity_domain/to_predicate.cpp \
       analyses/variable-sensitivity/variable_sensitivity_test_helpers.cpp \
       ansi-c/allocate_objects.cpp \
       ansi-c/expr2c.cpp \
       ansi-c/type2name.cpp \
       ansi-c/c_typecheck_base.cpp \
       big-int/big-int.cpp \
       compound_block_locations.cpp \
       get_goto_model_from_c_test.cpp \
       goto-cc/armcc_cmdline.cpp \
       goto-checker/properties/property_status.cpp \
       goto-checker/report_util/is_property_less_than.cpp \
       goto-instrument/cover_instrument.cpp \
       goto-instrument/cover/cover_only.cpp \
       goto-synthesizer/expr_enumerator/expr_enumerator.cpp \
       goto-programs/goto_program_assume.cpp \
       goto-programs/goto_program_dead.cpp \
       goto-programs/goto_program_declaration.cpp \
       goto-programs/goto_program_function_call.cpp \
       goto-programs/goto_program_goto_target.cpp \
       goto-programs/goto_program_goto_program_inline.cpp \
       goto-programs/goto_program_symbol_type_table_consistency.cpp \
       goto-programs/goto_program_table_consistency.cpp \
       goto-programs/goto_program_validate.cpp \
       goto-programs/goto_trace_output.cpp \
       goto-programs/is_goto_binary.cpp \
       goto-programs/label_function_pointer_call_sites.cpp \
       goto-programs/osx_fat_reader.cpp \
       goto-programs/restrict_function_pointers.cpp \
       goto-programs/structured_trace_util.cpp \
       goto-programs/remove_returns.cpp \
       goto-programs/xml_expr.cpp \
       goto-symex/apply_condition.cpp \
       goto-symex/complexity_limiter.cpp \
       goto-symex/expr_skeleton.cpp \
       goto-symex/goto_symex_state.cpp \
       goto-symex/ssa_equation.cpp \
       goto-symex/is_constant.cpp \
       goto-symex/shadow_memory_util.cpp \
       goto-symex/symex_assign.cpp \
       goto-symex/symex_level0.cpp \
       goto-symex/symex_level1.cpp \
       goto-symex/try_evaluate_pointer_comparisons.cpp \
       interpreter/interpreter.cpp \
       json/json_parser.cpp \
       json_symbol_table.cpp \
       path_strategies.cpp \
       pointer-analysis/value_set.cpp \
       solvers/bdd/miniBDD/miniBDD.cpp \
       solvers/flattening/boolbv.cpp \
       solvers/flattening/boolbv_update_bit.cpp \
       solvers/floatbv/float_utils.cpp \
       solvers/prop/bdd_expr.cpp \
       solvers/sat/external_sat.cpp \
       solvers/sat/satcheck_cadical.cpp \
       solvers/sat/satcheck_minisat2.cpp \
       solvers/smt2/smt2_conv.cpp \
       solvers/smt2/smt2irep.cpp \
       solvers/smt2_incremental/ast/smt_commands.cpp \
       solvers/smt2_incremental/ast/smt_index.cpp \
       solvers/smt2_incremental/ast/smt_responses.cpp \
       solvers/smt2_incremental/ast/smt_sorts.cpp \
       solvers/smt2_incremental/ast/smt_terms.cpp \
       solvers/smt2_incremental/construct_value_expr_from_smt.cpp \
       solvers/smt2_incremental/convert_expr_to_smt.cpp \
       solvers/smt2_incremental/object_tracking.cpp \
       solvers/smt2_incremental/smt2_incremental_decision_procedure.cpp \
       solvers/smt2_incremental/smt_is_dynamic_object.cpp \
       solvers/smt2_incremental/smt_object_size.cpp \
       solvers/smt2_incremental/smt_response_validation.cpp \
       solvers/smt2_incremental/smt_to_smt2_string.cpp \
       solvers/smt2_incremental/encoding/struct_encoding.cpp \
       solvers/smt2_incremental/encoding/enum_encoding.cpp \
       solvers/smt2_incremental/encoding/nondet_padding.cpp \
       solvers/smt2_incremental/theories/smt_array_theory.cpp \
       solvers/smt2_incremental/theories/smt_bit_vector_theory.cpp \
       solvers/smt2_incremental/theories/smt_core_theory.cpp \
       solvers/strings/array_pool/array_pool.cpp \
       solvers/strings/string_constraint_generator_valueof/calculate_max_string_length.cpp \
       solvers/strings/string_constraint_generator_valueof/get_numeric_value_from_character.cpp \
       solvers/strings/string_constraint_generator_valueof/is_digit_with_radix.cpp \
       solvers/strings/string_format_builtin_function/length_for_format_specifier.cpp \
       solvers/strings/string_format_builtin_function/length_of_decimal_int.cpp \
       solvers/strings/string_refinement/concretize_array.cpp \
       solvers/strings/string_refinement/sparse_array.cpp \
       solvers/strings/string_refinement/string_refinement.cpp \
       solvers/strings/string_refinement/substitute_array_list.cpp \
       solvers/strings/string_refinement/union_find_replace.cpp \
       util/bitvector_expr.cpp \
       util/cmdline.cpp \
       util/dense_integer_map.cpp \
       util/edit_distance.cpp \
       util/expr_cast/expr_cast.cpp \
       util/expr_initializer.cpp \
       util/expr.cpp \
       util/expr_iterator.cpp \
       util/format.cpp \
       util/format_expr.cpp \
       util/format_number_range.cpp \
       util/format_type.cpp \
       util/get_base_name.cpp \
       util/graph.cpp \
       util/help_formatter.cpp \
       util/interval/add.cpp \
       util/interval/bitwise.cpp \
       util/interval/comparisons.cpp \
       util/interval/divide.cpp \
       util/interval/eval.cpp \
       util/interval/get_extreme.cpp \
       util/interval/modulo.cpp \
       util/interval/multiply.cpp \
       util/interval/shift.cpp \
       util/interval/subtract.cpp \
       util/interval/to_string.cpp \
       util/interval_constraint.cpp \
       util/interval_union.cpp \
       util/irep.cpp \
       util/irep_sharing.cpp \
       util/invariant.cpp \
       util/json_array.cpp \
       util/json_object.cpp \
       util/lazy.cpp \
       util/lower_byte_operators.cpp \
       util/max_malloc_size.cpp \
       util/memory_info.cpp \
       util/message.cpp \
       util/optional_utils.cpp \
       util/parse_options.cpp \
       util/piped_process.cpp \
       util/pointer_expr.cpp \
       util/pointer_offset_size.cpp \
       util/prefix_filter.cpp \
       util/range.cpp \
       util/replace_symbol.cpp \
       util/run.cpp \
       util/sharing_map.cpp \
       util/sharing_node.cpp \
       util/simplify_expr.cpp \
       util/small_map.cpp \
       util/small_shared_n_way_ptr.cpp \
       util/ssa_expr.cpp \
       util/std_expr.cpp \
       util/string2int.cpp \
       util/structured_data.cpp \
       util/string_utils/capitalize.cpp \
       util/string_utils/escape_non_alnum.cpp \
       util/string_utils/join_string.cpp \
       util/string_utils/split_string.cpp \
       util/string_utils/strip_string.cpp \
       util/string_utils/wrap_line.cpp \
       util/symbol_table.cpp \
       util/symbol.cpp \
       util/unicode.cpp \
       util/xml.cpp \
       # Empty last line

ifndef WITH_MEMORY_ANALYZER
  ifeq ($(OS),Windows_NT)
    WITH_MEMORY_ANALYZER = 0
  else
    detected_OS := $(shell sh -c 'uname 2>/dev/null || echo Unknown')
    detected_ARCH := $(shell sh -c 'uname -m 2>/dev/null || echo Unknown')
    ifeq ($(filter-out Linux_x86_64 Linux_i386,$(detected_OS)_$(detected_ARCH)),)
      WITH_MEMORY_ANALYZER = 1
    else
      WITH_MEMORY_ANALYZER = 0
    endif
  endif
endif

ifeq ($(WITH_MEMORY_ANALYZER),1)
  SRC += memory-analyzer/gdb_api.cpp
endif

INCLUDES= -I ../src/ -I.

CPROVER_DIR = .
include ../src/config.inc
include ../src/common

cprover.dir:
	$(MAKE) $(MAKEARGS) -C ../src

testing-utils/testing-utils$(LIBEXT): cprover.dir
	$(MAKE) $(MAKEARGS) -C testing-utils

testing-utils-clean:
	$(MAKE) $(MAKEARGS) -C testing-utils clean

# We need to link bmc.o to the unit test, so here's everything it depends on...
BMC_DEPS =../src/cbmc/c_test_input_generator$(OBJEXT) \
          ../src/cbmc/cbmc_languages$(OBJEXT) \
          ../src/cbmc/cbmc_parse_options$(OBJEXT) \
          ../src/goto-cc/armcc_cmdline$(OBJEXT) \
          ../src/goto-cc/goto_cc_cmdline$(OBJEXT) \
          ../src/goto-instrument/source_lines$(OBJEXT) \
          ../src/goto-instrument/cover$(OBJEXT) \
          ../src/goto-instrument/cover_basic_blocks$(OBJEXT) \
          ../src/goto-instrument/cover_filter$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_assume$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_branch$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_condition$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_decision$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_location$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_mcdc$(OBJEXT) \
          ../src/goto-instrument/cover_instrument_other$(OBJEXT) \
          ../src/goto-instrument/cover_util$(OBJEXT) \
          ../src/goto-instrument/goto_program2code$(OBJEXT) \
          ../src/goto-instrument/reachability_slicer$(OBJEXT) \
          ../src/goto-instrument/nondet_static$(OBJEXT) \
          ../src/goto-instrument/full_slicer$(OBJEXT) \
          ../src/goto-instrument/unwindset$(OBJEXT) \

=== jbmc/regression/CMakeLists.txt ===
set(test_pl_path "${CBMC_SOURCE_DIR}/regression/test.pl")

# For the best possible utilisation of multiple cores when
# running tests in parallel, it is important that these directories are
# listed with decreasing runtimes (i.e. longest running at the top)
add_subdirectory(jbmc)
add_subdirectory(strings-smoke-tests)
add_subdirectory(jbmc-strings)
add_subdirectory(jdiff)
add_subdirectory(janalyzer)
add_subdirectory(janalyzer-taint)
add_subdirectory(jbmc-concurrency)
add_subdirectory(jbmc-inheritance)
add_subdirectory(jbmc-generics)
add_subdirectory(jbmc-json-ui)

=== jbmc/src/Makefile ===
DIRS = janalyzer jbmc jdiff java_bytecode miniz
ROOT = ../

include config.inc

.PHONY: all
all: janalyzer.dir jbmc.dir jdiff.dir

# building cbmc proper
.PHONY: cprover.dir
cprover.dir:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src

.PHONY: java_bytecode.dir
java_bytecode.dir: miniz.dir

.PHONY: janalyzer.dir
janalyzer.dir: java_bytecode.dir cprover.dir

.PHONY: jbmc.dir
jbmc.dir: java_bytecode.dir cprover.dir

.PHONY: jdiff.dir
jdiff.dir: java_bytecode.dir cprover.dir

.PHONY: miniz.dir
miniz.dir:

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files

.PHONY: generated_files
generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

.PHONY: clean
clean: $(patsubst %, %_clean, $(DIRS)) cprover_clean dist_clean

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

.PHONY: cprover_clean
cprover_clean:
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src clean

.PHONY: dist_clean
dist_clean:
	rm -rf $(ROOT)dist

setup-submodules:
	git submodule update --init

.PHONY: dist
dist: setup-submodules all
	mkdir -p $(ROOT)dist/lib
	cp ../lib/java-models-library/target/core-models.jar $(ROOT)dist/lib
	cp ../lib/java-models-library/target/cprover-api.jar $(ROOT)dist/lib
	mkdir -p $(ROOT)dist/bin
	cp jbmc/jbmc $(ROOT)dist/bin
	cp janalyzer/janalyzer $(ROOT)dist/bin
	cp jdiff/jdiff $(ROOT)dist/bin

.PHONY: install
install: setup-submodules all
	$(MAKE) $(MAKEARGS) -C $(CPROVER_DIR)/src install
	cp ../lib/java-models-library/target/core-models.jar $(PREFIX)/lib/
	cp ../lib/java-models-library/target/cprover-api.jar $(PREFIX)/lib/
	cp jbmc/jbmc $(PREFIX)/bin/
	cp janalyzer/janalyzer $(PREFIX)/bin/
	cp jdiff/jdiff $(PREFIX)/bin/
	cp ../../doc/man/j* $(PREFIX)/doc/man/man1/

=== jbmc/unit/CMakeLists.txt ===
file(GLOB_RECURSE sources "*.cpp" "*.h")
list(APPEND sources  ${CBMC_SOURCE_DIR}/unit/unit_tests.cpp)

file(GLOB_RECURSE java-testing_utils "java-testing-utils/*.cpp" "java-testing-utils/*.h")

list(REMOVE_ITEM sources
    # Will be built into a separate library and linked
    ${java-testing_utils}
)

add_subdirectory(java-testing-utils)

add_executable(java-unit ${sources})
target_include_directories(java-unit
    PUBLIC
    ${CBMC_BINARY_DIR}
    ${CBMC_SOURCE_DIR}/src
    ${CBMC_SOURCE_DIR}/unit
    ${CMAKE_CURRENT_SOURCE_DIR}
)
target_link_libraries(java-unit
        java-testing-utils
        testing-utils
        ansi-c
        solvers
        goto-checker
        goto-programs
        goto-symex
        goto-instrument-lib
        cbmc-lib
        json-symtab-language
)

add_test(
    NAME java-unit
    COMMAND $<TARGET_FILE:java-unit>
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_test(
    NAME java-unit-xfail
    COMMAND $<TARGET_FILE:java-unit> "[!shouldfail]"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

set_tests_properties(java-unit PROPERTIES LABELS "CORE;CBMC")

=== regression/acceleration/Makefile ===
default: tests.log

include ../../src/config.inc
include ../../src/common

GOTO_INSTRUMENT_EXE=../../../src/goto-instrument/goto-instrument
CBMC_EXE=../../../src/cbmc/cbmc

ifeq ($(BUILD_ENV_),MSVC)
	GOTO_CC_EXE=../../../src/goto-cc/goto-cl
	is_windows=true
else
	GOTO_CC_EXE=../../../src/goto-cc/goto-cc
	is_windows=false
endif

test:
	@../test.pl -e -p -c "../accelerate.sh $(GOTO_CC_EXE) $(GOTO_INSTRUMENT_EXE) $(CBMC_EXE) $(is_windows)"

tests.log: ../test.pl
	@../test.pl -e -p -c "../accelerate.sh $(GOTO_CC_EXE) $(GOTO_INSTRUMENT_EXE) $(CBMC_EXE) $(is_windows)"

clean:
	$(RM) tests.log
	find . -name '*.gb' -execdir $(RM) '{}' \;
	find . -name '*.out' -execdir $(RM) '{}' \;

=== regression/cbmc-cover/Makefile ===
default: tests.log

test:
	@../test.pl -e -p -c ../../../src/cbmc/cbmc

tests.log: ../test.pl
	@../test.pl -e -p -c ../../../src/cbmc/cbmc

clean:
	find . -name '*.out' -execdir $(RM) '{}' \;
	find . -name '*.gb' -execdir $(RM) '{}' \;
	$(RM) tests.log

=== regression/cbmc-cpp/CMakeLists.txt ===
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set(gcc_only -X gcc-only)
else()
  set(gcc_only "")
endif()

add_test_pl_tests(
    "$<TARGET_FILE:cbmc> --validate-goto-model --validate-ssa-equation" ${gcc_only}
)

=== regression/cpp/Makefile ===
default: tests.log

include ../../src/config.inc
include ../../src/common

ifeq ($(BUILD_ENV_),MSVC)
	exe = ../../../src/goto-cc/goto-cl
else
	exe = ../../../src/goto-cc/goto-cc
endif

ifeq ($(BUILD_ENV_),MSVC)
	excluded_tests = -X gcc-only
endif

test:
	@../test.pl -e -p -c $(exe) $(excluded_tests)
tests.log: ../test.pl
	@../test.pl -e -p -c $(exe) $(excluded_tests)

clean:
	find . -name '*.out' -execdir $(RM) '{}' \;
	find . -name '*.gb' -execdir $(RM) '{}' \;
	$(RM) tests.log

=== regression/goto-cc-cbmc/Makefile ===
default: tests.log

include ../../src/config.inc
include ../../src/common

ifeq ($(BUILD_ENV_),MSVC)
	exe=../../../src/goto-cc/goto-cl
	is_windows=true
else
	exe=../../../src/goto-cc/goto-cc
	is_windows=false
endif

test:
	@../test.pl -e -p -c '../chain.sh $(exe) ../../../src/cbmc/cbmc $(is_windows)'

tests.log:
	@../test.pl -e -p -c '../chain.sh $(exe) ../../../src/cbmc/cbmc $(is_windows)'

clean:
	$(RM) tests.log
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			cd "$$dir"; \
			$(RM) *.out *.gb; \
			cd ..; \
		fi \
	done

=== regression/goto-cc-file-local/Makefile ===
default: tests.log

include ../../src/config.inc
include ../../src/common

ifeq ($(BUILD_ENV_),MSVC)
	exe=../../../src/goto-cc/goto-cl
	is_windows=true
else
	exe=../../../src/goto-cc/goto-cc
	is_windows=false
endif

test:
	@../test.pl -e -p -c '../chain.sh $(exe) ../../../src/goto-instrument/goto-instrument ../../../src/cbmc/cbmc $(is_windows)'

tests.log:
	@../test.pl -e -p -c '../chain.sh $(exe) ../../../src/goto-instrument/goto-instrument ../../../src/cbmc/cbmc $(is_windows)'

clean:
	$(RM) tests.log
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			cd "$$dir"; \
			$(RM) *.out *.gb; \
			cd ..; \
		fi \
	done

=== debian/changelog ===
cbmc (6.4.1-2) unstable; urgency=low

  * Fix portability problems

 -- Michael Tautschnig <mt@debian.org>  Wed, 22 Jan 2025 08:38:54 +0000

cbmc (6.4.1-1) unstable; urgency=low

  * New upstream release
  * Fix Maven versioned dependency (Closes: #1091116)

 -- Michael Tautschnig <mt@debian.org>  Tue, 21 Jan 2025 11:40:10 +0000

=== debian/control ===
Source: cbmc
Section: science
Priority: optional
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 bison,
 flex,
 minisat (>= 1:2.2.1-2),
 zlib1g-dev,
 gdb [amd64],
 libxml2-utils,
 python-is-python3,
 z3 [!sh4],
 cvc5 [!armel !armhf !i386 !mips64el !hppa !hurd-amd64 !hurd-i386 !ia64 !loong64 !powerpc !sh4 !x32],
 default-jdk-headless [!arc !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !loong64],
 libmaven-dependency-plugin-java [!arc !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !loong64],
 libmaven-install-plugin-java [!arc !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !loong64],
 maven-debian-helper [!arc !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !loong64]
Standards-Version: 4.7.0
Homepage: http://www.cprover.org/cbmc/
Rules-Requires-Root: no

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Suggests: gdb
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

Package: jbmc
Architecture: alpha amd64 arm64 armel armhf i386 ia64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: java-compiler
Description: bounded model checker for Java programs
 JBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.
